	TITLE IDETOOL

	PAGE 66

				; +-------------------------------+
				; | IDEtool               2000 AK |
				; | 8255 PPI 16bit IDE Interface  |
				; | Z80/HD64180 Version, M80 Code |
				; |                               |
				; | Laufwerke bis 8GB moeglich!   |
				; +-------------------------------+

				; See http://www.prjc.com/tech/8051/ide/ for more information!

				; IDE Test & Formatierprogramm, benoetigt CPMLIB.
				; 16+8 = 24bit (FFFFFFH) 16777215 LBAs x 512/1024 = 8.388607GB 
				; Aktuell sollte das reichen, d.h. lba+3 wird nicht gesetzt ;-)!
	
; Update:
;
; 14.02.2022	030		Kosmetik
;	
; 11.02.2022	028	V1.20	Bug in format and verify loop fixed
; 05.02.2022	025		Show I/O and buffer adress
;
; 03.01.2022	021	V1.19	Info LBA supported y/n, prnlba and 0fh
;
; 12.04.2021	018	V1.18	ide_rd_8, ide_wr_8, write_data no nops
;
; 08.04.2021	017	V1.17	Format with lba+2, Verify bugfix cp 0
;					
; 27.02.2021	015	V1.16	only one CRLF in the main_loop
;
; 09.01.2021	010	V1.15	mult32 for mult (> 32Mb)
;
; 01.07.2020    009     V1.14	jp for jr
;
; 23.06.2011	008	V1.13	push & pop af in lbainc/lbadec
;				Text erase / check data (ohne all)	
; 11.05.2010    007     V1.12	ide_init mit delay fuer alte HDD
;
; 16.12.2007    006     V1.11	"V" Verify (Check) bis 8GB
;
; 13.12.2007    005     V1.10	setlba 16+8 Bit
;
; 09.12.2007    001     V1.09	Neuer Name IDEtool
;                               "C" Check
;                               lbainc bis 8 GB
;                               nach format + check LBA auf 0
;                               crlf bei check und format
;
; 16.12.2006	035	V1.08	mult
;
; 14.10.2006	034	V1.07	ide_drv; lba buffer
;
; 26.05.2006	033	V1.06	Timeout, read- und write_sector
;				optimiert
; 20.05.2006	031	V1.05	ide_init, Select LBA modus in wr_lba
; 01.05.2006	030	V1.04	kosmetik, or a / cp 0
;					
; 22.04.2006	029	V1.03	Start, CHS: xxxx, xx, xx
;
; 16.04.2006	027	V1.02	Start, Devicetype anzeigen	
;		028		prnswp, keine Leerzeichen
;		026		kosmetik
;		023-025		format, Sectoren mit "E5" fuellen
;		022		lbainc+lbadec 16 Bit
;				setlba dto.			
;		021		crdump mit Kopfzeile
;				hexdump dto.
;		020		write_data optimiert
;				ide_wr_16 entfaellt
;
; 02.01.2006	019		read_data optimiert
;				ide_rd_16 entfaellt
;
;
	.Z80
	ASEG
;
FALSE	EQU	0
TRUE	EQU	NOT FALSE
;
TPA	EQU	0100H
;
BIFLAG	SET	FALSE
CIFLAG	SET	FALSE
CLFLAG	SET	FALSE
CMFLAG	SET	FALSE
COFLAG	SET	FALSE
CRFLAG	SET	FALSE
CXFLAG	SET	FALSE
DEFLAG	SET	FALSE
DMFLAG	SET	FALSE
EOLFLG	SET	FALSE
FNFLAG	SET	FALSE
GTFLAG	SET	FALSE
GOFLAG	SET	FALSE
HXFLAG	SET	FALSE
MKFLAG	SET	FALSE
OPFLAG	SET	FALSE
PRFLAG	SET	FALSE
RCFLAG	SET	FALSE
RDFLAG	SET	FALSE
RNFLAG	SET	FALSE
S2FLAG	SET	FALSE
UNFLAG	SET	FALSE
WAFLAG	SET	FALSE
WRFLAG	SET	FALSE
;
	.XLIST
	MACLIB CPMLIB
	.LIST
;
	BELL EQU 7
;
	@BDOS EQU 5
	@CONIN EQU 1
	@CONOUT EQU 2
	@PRINT$ EQU 9
;
	PIO_IDE EQU 040H	; 8255 PPI I/O adress
	BUFFER EQU 6000H	; for debugging with ddt/sid
;
	PIO_LSB EQU 0 + PIO_IDE	; Port A
	PIO_MSB EQU 1 + PIO_IDE	; Port B
	PIO_CTL EQU 2 + PIO_IDE	; Port C
	PIO_CFG EQU 3 + PIO_IDE	; I/O mode
;
	PIO_RDW EQU 10010010B	; Port A+B input, Port C output
	PIO_WR EQU 10000000B	; Port A+B+C output
;
	IDE_DRV EQU 11100000B	; select the device
				; x1x00000b LBA master
				; x1x10000b LBA slave
				; x0x00000b CHS master
				; x0x10000b CHS slave
;
	IDE_A0  EQU 00000001B	; A0 direct to IDE HDD
	IDE_A1  EQU 00000010B	; A1 dto.
	IDE_A2  EQU 00000100B	; A2 dto.
	IDE_CS0  EQU 00001000B	; CS0 to Inverter 
	IDE_CS1  EQU 00010000B	; CS1 dto.
	IDE_WR  EQU 00100000B	; WR dto.
	IDE_RD  EQU 01000000B	; RD dto.
	IDE_RST  EQU 10000000B	; RST dto.
;
	IDE_DATA EQU IDE_CS0
	IDE_ERR  EQU IDE_CS0 + IDE_A0
	IDE_SEC_CNT EQU IDE_CS0 + IDE_A1
	IDE_SECTOR EQU IDE_CS0 + IDE_A1 + IDE_A0
	IDE_CYL_LSB EQU IDE_CS0 + IDE_A2
	IDE_CYL_MSB EQU IDE_CS0 + IDE_A2 + IDE_A0
	IDE_HEAD EQU IDE_CS0 + IDE_A2 + IDE_A1
	IDE_COMMAND EQU IDE_CS0 + IDE_A2 + IDE_A1 + IDE_A0
	IDE_STATUS EQU IDE_CS0 + IDE_A2 + IDE_A1 + IDE_A0
	IDE_CONTROL EQU IDE_CS1 + IDE_A2 + IDE_A1
	IDE_ASTATUS EQU IDE_CS1 + IDE_A2 + IDE_A1 + IDE_A0
;
	IDE_CMD_RECAL EQU 010H
	IDE_CMD_READ EQU 020H
	IDE_CMD_WRITE EQU 030H
	IDE_CMD_INIT EQU 091H
	IDE_CMD_ID EQU 0ECH
	IDE_CMD_SPINDN EQU 0E0H
	IDE_CMD_SPINUP EQU 0E1H
;
	ORG	TPA
;
START:
	VERSN 'IDEtool'
	ENTER
;
	LXI	D,MSG_1		; Hello
	CALL	PRNTXT
;
	LXI	D,MSG_IOA	; I/O adress
	CALL	PRNTXT
	MVI	A,PIO_IDE
	OUTHEX
	PCHAR 'H'		; HEX
;
	LXI	D,MSG_BUF	; Buffer adress
	CALL	PRNTXT
	LXI	H,BUFFER
	OUTHL
	PCHAR 'H'		; HEX
	CRLF
	CRLF
;
	CALL	IDE_HARD_RESET	; Drive Reset
	CALL	IDE_INIT	; Drive Init
	JC	FERTIG		; no HDD/CFC found
;
	CALL	DRIVE_ID	; Get Drive id info

	LXI	D,MSG_MDL
	CALL	PRNTXT
	LXI	H,BUFFER+54	; model number
	MVI	B,20
	CALL	PRNSWP
	CRLF
;
	LXI	D,MSG_SN
	CALL	PRNTXT
	LXI	H,BUFFER+20	; serial number
	MVI	B,10
	CALL	PRNSWP
	CRLF
;
	LXI	D,MSG_REV
	CALL	PRNTXT
	LXI	H,BUFFER+46	; firmware revision
	MVI	B,4
	CALL	PRNSWP
	CRLF
;
	LXI	D,MSG_ID	; device type
	CALL	PRNTXT
	LDA	BUFFER+1
	ANI	80H		; Bit 7
	JNZ	ATAPI
	LXI	D,MSG_ATA
	JMP	ATA
ATAPI:
	LXI	D,MSG_API
ATA:
	CALL	PRNTXT
;
	LDA	BUFFER
	ANI	40H		; Bit 6
	JNZ	REMOV
	LXI	D,MSG_REM
	JMP	FIXED
REMOV:
	LXI	D,MSG_FIX
FIXED:
	CALL	PRNTXT
	CRLF
;
	LXI	D,MSG_CHS
	CALL	PRNTXT
	LDA	BUFFER+2	; cylinder
	MOV	L,A
	LDA	BUFFER+3
	MOV	H,A
	SHLD	MAXCYL
	HLDEC
;
	LXI	D,MSG_SPC
	CALL	PRNTXT
	LDA	BUFFER+6	; heads
	MOV	L,A
	LDA	BUFFER+7
	MOV	H,A
	SHLD	MAXHDS
	HLDEC
;
	LXI	D,MSG_SPC
	CALL	PRNTXT
	LDA	BUFFER+12	; sectors
	MOV	L,A
	LDA	BUFFER+13
	MOV	H,A
	SHLD	MAXSEC
	HLDEC
	CRLF
;
	LXI	D,MSG_LBS	; LBA supported?
	CALL	PRNTXT
	LDA	BUFFER+99	; Word 49 +1
	ANI	2		; Bit 0 = DMA, Bit 1 = LBA
	JZ	LBA_NO
	LXI	D,MSG_YES
	JMP	LBA_YES
LBA_NO:
	LXI	D,MSG_NO
LBA_YES:
	CALL	PRNTXT
	CRLF
;
	LXI	D,MSG_MLBA	; max. LBA
	CALL	PRNTXT
	# LD  BC,(MAXHDS)
	# LD DE,(MAXSEC)
	CALL	MULT32
	
	PUSH	H		; nach BC
	POP	B
	# LD DE,(MAXCYL)
	CALL	MULT32

	PUSH	H		; und ausgeben
	PUSH	B
	POP	H
	OUTHL
	POP	H
	DCX	H		; -1
	OUTHL
	CRLF
;
	LXI	D,MSG_STA	; Drive Status
	CALL	PRNTXT
	CALL	IDE_GET_ASTATUS
	OUTHEX
	CRLF
	CRLF
;
; loop
;
MAIN_LOOP:
	CALL	PRNLBA
	LXI	D,MSG_PMT
	CALL	PRNTXT
	CALL	CI
	CRLF

	CPI	'+'
	CZ	LBAINC
	
	CPI	'-'
	CZ	LBADEC

	CPI	'U'		; spinup
	CZ	SPINUP

	CPI	'O'		; spindn
	CZ	SPINDN

	CPI	'D'		; chrdump
	CZ	CHRDUMP

	CPI	'H'		; hexdump
	CZ	HEXDUMP

	CPI	'L'		; set LBA
	CZ	SETLBA

	CPI	'R'		; read sector
	CZ	READSEC

	CPI	'W'		; write sector
	CZ	WRITESEC

	CPI	'F'		; fill with e5h
	CZ	FORMAT

	CPI	'V'		; read sector(s)
	CZ	VERIFY

	CPI	'Q'		; quit
	CZ	FERTIG

	JMP	MAIN_LOOP

;
; 32 bit multiplikation
; BCxDE = BCHL (16*16=32)
;
MULT32:
	MOV	A,C
	MOV	C,B
	LXI	H,0
	MVI	B,16
MULT32LP:
	DAD	H
	RAL
	# RL C
	JNC	MULT32NA
	DAD	D
	ACI	0
	JNC	MULT32NA
	INR	C
MULT32NA:
	# DJNZ MULT32LP
	MOV	B,C
	MOV	C,A
	RET
;
; conout
;
CO:
	MVI	C,@CONOUT
	CALL	@BDOS
	RET
;
; conin
;
CI:
	MVI	C,@CONIN
	CALL	@BDOS
	CPI	"A"
	RC
	CPI	"{"
	RNC
	ANI	"_"
	RET
;
; print text
;
PRNTXT:
	MVI	C,@PRINT$
	CALL	@BDOS
	RET
;
PRNSWP:
	MOV	A,M
	MOV	C,A
	INX	H
	MOV	A,M
	INX	H
	CPI	' '		; no blanks
	JZ	NOBL
	PCHAR
NOBL:
	MOV	A,C
	CPI	' '		; no blanks
	JZ	NOBL1
	PCHAR
NOBL1:
	DCR	B
	MOV	A,B
	JNZ	PRNSWP
	RET

;
; Show LBA prompt
;
PRNLBA:
	LXI	D,MSG_LBA
	CALL	PRNTXT
	LDA	LBA+3		; head
	ANI	0FH		; 0-15
	OUTHEX
	LDA	LBA+2		; cyl_msb
	OUTHEX
	LDA	LBA+1		; cyl_lsb
	OUTHEX
	LDA	LBA		; sector
	OUTHEX
	RET

;
; Set LBA low
;
SETLBA:
	LXI	D,MSG_CYH
	CALL	PRNTXT
	READB
	HEXHL
	JC	SETLBA		; input error
	SHLD	LBA
	CRLF
				; 
				; and high
SETHLBA:
	LXI	D,MSG_HCYH
	CALL	PRNTXT
	READB
	HEXHL
	JC	SETHLBA
	MOV	A,L
	STA	LBA+2		; 8 Bit
	CRLF
	XRA	A
	RET

;
; LBA +1, max. 8 GB
;
LBAINC:
	PUSH	PSW
	LHLD	LBA		; LBA (sektor) +1
	INX	H
	SHLD	LBA
	MOV	A,L		; auf ueberlauf pruefen
	ORA	H
	JNZ	LBAIRET		; kleiner FFFF
	LDA	LBA+2
	INR	A
	STA	LBA+2
LBAIRET:
	POP	PSW
	RET

;
; LBA -1, max. 8 GB
;
LBADEC:
	PUSH	PSW
	LHLD	LBA		; LBA (sektor) -1
	DCX	H
	SHLD	LBA
	INX	H		; +1
	MOV	A,L
	ORA	H
	JNZ	LBADRET
	LDA	LBA+2
	DCR	A
	STA	LBA+2
LBADRET:
	POP	PSW
	RET

;
; Read one sector from drive
;
READSEC:
	CALL	READ_SECTOR
	JZ	READ_OK
	PUSH	PSW
	LXI	D,MSG_ERR
	CALL	PRNTXT
	POP	PSW
	OUTHEX			; print error code
	CRLF
	RET
READ_OK:
	LXI	D,MSG_RD
	CALL	PRNTXT
	RET

;
; Write on sector to drive
;
WRITESEC:
	LXI	D,MSG_SUR
	CALL	PRNTXT
	CALL	CI
	CPI	'Y'
	JNZ	WRITE_EX
	CRLF
	CZ	WRITE_SECTOR
	JZ	WRITE_OK
	PUSH	PSW
	LXI	D,MSG_ERR
	CALL	PRNTXT
	POP	PSW
	OUTHEX			; print error code
WRITE_EX:
	CRLF
	RET
WRITE_OK:
	LXI	D,MSG_WR
	CALL	PRNTXT
	RET

;
; ASCII dump 
; 512 byte buffer
;
CHRDUMP:
	CRLF
	LXI	D,MSG_012
	CALL	PRNTXT
	LXI	B,512
	LXI	H,BUFFER
CHRLP:
	MVI	D,32
	OUTHL
	PCHAR ' '
CHRLP1:
	MOV	A,M
	CPI	' '
	JC	CHR1
	CPI	7FH
	JNC	CHR1
	PCHAR
	JMP	CHR2
CHR1:
	MVI	A,'.'
	PCHAR
CHR2:
	INX	H
	DCX	B
	DCR	D
	MOV	A,D
	JNZ	CHRLP1
	CRLF
	MOV	A,B
	ORA	C
	JNZ	CHRLP
	CRLF
	XRA	A
	RET

;
; HEX dump
; 512 byte buffer
;
HEXDUMP:
	CRLF
	LXI	D,MSG_000
	CALL	PRNTXT
	LXI	B,512
	LXI	H,BUFFER
HEXLP:
	MVI	D,32
	OUTHL
	PCHAR ' '
HEXLP1:
	MOV	A,M
	OUTHEX
	INX	H
	DCX	B
	DCR	D
	MOV	A,D
	JNZ	HEXLP1
	CRLF
	MOV	A,B
	ORA	C
	JNZ	HEXLP
	CRLF
	XRA	A
	RET

;
; Drive spin up/down
;
SPINDN:
	CALL	IDE_WAIT_NOT_BUSY
	MVI	C,IDE_CMD_SPINDN
	JMP	SPUP2
				; 
				; Drive spin up
SPINUP:
	MVI	C,IDE_CMD_SPINUP
SPUP2:
	MVI	A, IDE_COMMAND
	CALL	IDE_WR_8
	CALL	IDE_WAIT_NOT_BUSY
	XRA	A		; clear
	RET

;
; Format, fill sectors with E5h
;
FORMAT:
	LXI	D,MSG_FMT
	CALL	PRNTXT
	CALL	CI
	CPI	'Y'
	JNZ	FMT_EX
	CRLF
	LXI	H,BUFFER
	LXI	B,512
				; 
				; fill buffer with E5H
FILL_LP:
	MVI	A,0E5H
	MOV	M,A
	INX	H
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	FILL_LP
				; 
	LDA	LBA+2		; cyl msb (8 bit)
	INR	A		; +1
	MOV	D,A
				; 
				; format loop
FMT_L0:				; aeussere schleife
	PUSH	D
	# LD BC,(LBA)		; sector + cyl lsb
	INX	B		; +1
FMT_LP:
	PUSH	B
	CALL	WRITE_SECTOR
	JNZ	FMT_ERR
	CALL	PRNLBA
	PCHAR CR
	CALL	LBADEC		; LBA = LBA -1
	ABORT ESC
	POP	B
	DCX	B		; counter -1
	MOV	A,B
	ORA	C
	JNZ	FMT_LP		; bis fertig
				; 	
	POP	D		; cyl msb 0?
	DCR	D
	MOV	A,D
	ORA	A		; fertig?
	JNZ	FMT_L0
				; 
	CALL	LBAINC		; zurueck auf LBA 0
	LXI	D,MSG_FT
	CALL	PRNTXT
	JMP	FMT_EX		; fertig
;
FMT_ERR:
	PUSH	PSW
	LXI	D,MSG_ERR
	CALL	PRNTXT
	POP	PSW
	OUTHEX			; print error code
FMT_EX:
	CRLF
	RET

;
; Verify, read sectors
;
VERIFY:
	LXI	D,MSG_CHK
	CALL	PRNTXT
	CALL	CI
	CPI	'Y'
	JNZ	CHK_EX
	CRLF
	LDA	LBA+2		; cyl msb (8 bit)
	INR	A		; +1
	MOV	D,A
CHK_L0:				; aeussere schleife
	PUSH	D		; sichern
	# LD BC,(LBA)		; sector + cyl lsb
	INX	B		; +1
CHK_LP:				; innere schleife
	PUSH	B
	CALL	READ_SECTOR
	JNZ	CHK_ERR
	CALL	PRNLBA
	PCHAR CR
	CALL	LBADEC		; LBA = LBA -1
	ABORT ESC
	POP	B
	DCX	B		; counter -1
	MOV	A,B
	ORA	C
	JNZ	CHK_LP
				; 
	POP	D		; cyl msb 0?
	DCR	D
	MOV	A,D
	ORA	A		; fertig?
	JNZ	CHK_L0
				; 
	CALL	LBAINC		; zurueck auf LBA 0
	LXI	D,MSG_CT
	CALL	PRNTXT
	JMP	CHK_EX		; fertig
;
CHK_ERR:
	POP	D		; Stack korrigieren
	POP	B
	PUSH	PSW		; Fehlercode sichern
	LXI	D,MSG_ERR
	CALL	PRNTXT
	POP	PSW
	OUTHEX			; print error code
CHK_EX:
	CRLF
	RET

				; aborted
DONE:	
	POP	D
	POP	B
	CRLF
	LXI	D,MSG_BRK
	CALL	PRNTXT
	CALL	LBAINC		; set LBA -1
	JMP	CHK_EX

				; 
				; IDE I/O Routinen
;
; Initalize the drive
;
IDE_INIT:
	MVI	A,IDE_HEAD
	MVI	C,IDE_DRV	; select the device
	CALL	IDE_WR_8
				; wait for ready
	LXI	D,0
IDE_RDY_BSY:
	MVI	B,0		; delay for slow drives
	# DJNZ    $
	DCX	D
	MOV	A,D
	ORA	E
	JZ	IDE_NOT_RDY	; timeout
	MVI	A,IDE_STATUS
	CALL	IDE_RD_8
	MOV	A,C
	# BIT 6,A		; if on then ready
	JZ	 IDE_RDY_BSY	; wait for READY bit to be set	
	# BIT 7,A		; if on then busy
	JNZ	 IDE_RDY_BSY	; wait for BUSY bit to be clear
	RET
IDE_NOT_RDY:
				; timeout
	LXI	D,NOMSG
	CALL	PRNTXT
	STC
	RET

;
; HD hard reset
;
IDE_HARD_RESET:
	MVI	A, PIO_RDW	; PIO Read/Write Mode
	# OUT (PIO_CFG), A
	MVI	A, IDE_RST	; hard reset drive
	# OUT (PIO_CTL), A
	PUSH	B
	LXI	B,3000		; ca. 10 ms delay
WLOOP:
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	WLOOP
	POP	B
	XRA	A		; no ide control lines asserted
	# OUT (PIO_CTL), A
	RET

;
; Wait for DRQ  
;
IDE_WAIT_DRQ:
	MVI	A,0FFH
	MOV	B,A
	STA	DELAY_DRQ
MORE_DRQ:
	
	MVI	A,IDE_STATUS
	CALL	IDE_RD_8
	MOV	A,C
	ANI	10001000B
	CPI	00001000B
	JZ	DONE_DRQ
	DCR	B
	JNZ	MORE_DRQ
	LDA	DELAY_DRQ
	DCR	A
	JNZ	MORE_DRQ
	STA	DELAY_DRQ
	STC
	RET
DONE_DRQ:
	XRA	A
	RET

DELAY_DRQ:
	DB	0

;
; Wait for BUSY to be clear
;	
IDE_WAIT_NOT_BUSY:
	MVI	A,0FFH
	MOV	B,A
	STA	DELAY_BUSY
MORE_BUSY:
	MVI	A,IDE_STATUS
	CALL	IDE_RD_8
	MOV	A,C
	ANI	11000000B
	XRI	01000000B
	JZ	NOT_BUSY
	DCR	B
	JNZ	MORE_BUSY
	LDA	DELAY_BUSY
	DCR	A
	STA	DELAY_BUSY
	JNZ	MORE_BUSY
	STC
	RET
NOT_BUSY:
	XRA	A
	RET

DELAY_BUSY:
	DB	0
	
;
; Get Active Status of the IDE Drive
;	
IDE_GET_ASTATUS:
	MVI	A,IDE_ASTATUS
	CALL	IDE_RD_8
	MOV	A,C
	RET

;
; 8 bit read
;
IDE_RD_8:
	MOV	D,A		; save adress to D
	OUT	PIO_CTL		; drive address onto control lines
	ORI	IDE_RD		; set read pin on
	OUT	PIO_CTL
;	nop			; delay 2x nop
;	nop
	IN	PIO_LSB		; read lower byte
	MOV	C,A		; to C
	MOV	A,D		; reset read pin first
	OUT	PIO_CTL
	XRA	A		; reset all control pins
	OUT	PIO_CTL
	RET

;
; 8 bit write 
;
IDE_WR_8:
	MOV	D,A		; save adress to D
				; Command, head, sector, cylinder etc. in C
	MVI	A, PIO_WR
	OUT	PIO_CFG		; PIO Write Mode
	MOV	A,C
	OUT	PIO_LSB		; Drive lower lines
	MOV	A,D		; Drive address onto control lines
	OUT	PIO_CTL
	ORI	IDE_WR		; set write pin on
	OUT	PIO_CTL
;	nop			; delay	2x nop
;	nop
	MOV	A,D
	OUT	PIO_CTL		; reset write pin first
	XRA	A
	OUT	PIO_CTL		; reset all control pins
	MVI	A,PIO_RDW
	OUT	PIO_CFG		; set PIO read/write mode
	RET

;
; Do the identify command and fill
; the buffer with the drive infos
;
DRIVE_ID:
	CALL	IDE_WAIT_NOT_BUSY
	MVI	A,IDE_HEAD
	MVI	C,IDE_DRV	; select the device
	CALL	IDE_WR_8
	CALL	IDE_WAIT_NOT_BUSY
	MVI	A,IDE_COMMAND
	MVI	C,IDE_CMD_ID	; 0ech
	CALL	IDE_WR_8	; issue the command
	CALL	IDE_WAIT_DRQ
	CALL	READ_DATA
	RET

;
; 16 bit read
;
READ_SECTOR:
				; hdread:
	CALL	IDE_WAIT_NOT_BUSY
	CALL	WR_LBA		; set sector
	MVI	A,IDE_COMMAND	; command register
	MVI	C,IDE_CMD_READ
	CALL	IDE_WR_8
	CALL	IDE_WAIT_DRQ
	CALL	READ_DATA
	CALL	IDE_WAIT_NOT_BUSY
	ANI	10001001B	; busy, DRQ or error
	RZ			; no
	JMP	GET_ERR

;
; 16 bit write
;
WRITE_SECTOR:
				; hdwrite:
	CALL	IDE_WAIT_NOT_BUSY
	CALL	WR_LBA		; set sector
	MVI	A,IDE_COMMAND	; command register
	MVI	C,IDE_CMD_WRITE
	CALL	IDE_WR_8
	CALL	IDE_WAIT_DRQ
	CALL	WRITE_DATA
	CALL	IDE_WAIT_NOT_BUSY
	ANI	10001001B	; busy, DRQ or error
	RZ			; no
				; 
				; Return with errors if occurs
GET_ERR:
	MVI	A,IDE_ERR
	CALL	IDE_RD_8
	MOV	A,C
	ORA	A		; set Zero Flag
	RET

;
; LBA = 28bit 4+3x8
; If CHS mode head 8-bit (0-254), sektor 6-bit (1-63)
; cylinder/track 10-bit (0-1023) = 24-bit / 8,38GB max.
;
WR_LBA:
	LDA	LBA+3		; 4/8-bit, CHS head 0-254
	ANI	0FH		; LBA 0-15
	ORI	IDE_DRV		; mode master/slave CHS/LBA
	MOV	C,A
	MVI	A,IDE_HEAD
	CALL	IDE_WR_8

	LDA	LBA+2		; 8-bit, CHS cyl msb
	MOV	C,A
	MVI	A,IDE_CYL_MSB
	CALL	IDE_WR_8

	LDA	LBA+1		; 8-bit, CHS cyl lsb
	MOV	C,A
	MVI	A,IDE_CYL_LSB
	CALL	IDE_WR_8

	LDA	LBA		; 8-bit, CHS sector
;	and	3fh			; 1-63 if CFC/CHS
	MOV	C,A
	MVI	A,IDE_SECTOR
	CALL	IDE_WR_8

	MVI	C,1		; transfer one sector
	MVI	A,IDE_SEC_CNT
	CALL	IDE_WR_8
	XRA	A
	RET

;
; Read one sector of 512 bytes
;
READ_DATA:
	MVI	B,0		; 256 words, 512 bytes per sector
	LXI	H,BUFFER	; target
READ_LP:
	MVI	A,IDE_DATA	; drive address onto control lines
	OUT	PIO_CTL		; and set read pin off (loop)
	ORI	IDE_RD
	OUT	PIO_CTL		; set read pin on
	IN	PIO_LSB		; read the lower byte
	MOV	M,A
	INX	H
	IN	PIO_MSB		; read the upper byte	
	MOV	M,A
	INX	H
	# DJNZ READ_LP
				; 
	XRA	A		; set all control pins of
	OUT	PIO_CTL
	RET

;
; Write one sector of 512 bytes
;
WRITE_DATA:
	MVI	B,0		; 256 words, 512 bytes per sector
	LXI	H,BUFFER	; source
	MVI	A, PIO_WR
	OUT	PIO_CFG		; PIO Write Mode
WRITE_LP:
	MOV	A,M
	OUT	PIO_LSB		; Drive lower lines with lsb
	INX	H
	MOV	A,M
	OUT	PIO_MSB		; Drive upper lines with msb
	INX	H
	MVI	A,IDE_DATA
	OUT	PIO_CTL		; Drive address onto control lines
	ORI	IDE_WR		; set write pin on
	OUT	PIO_CTL
;	nop			; delay
	MVI	A,IDE_DATA
	OUT	PIO_CTL		; reset write pin
	# DJNZ WRITE_LP
				; 
	XRA	A		; set all control pins of
	OUT	PIO_CTL
	MVI	A,PIO_RDW	; PIO Read/Write Mode	
	OUT	PIO_CFG
	RET

;
; finish
;
FERTIG:
	EXIT BOOT

;
; messages
;
MSG_1:	DB	'IDEtool v1.20-02.2022 AK',CR,LF,'$'
MSG_MDL:DB	' Model: ','$'
MSG_SN:	DB	'   S/N: ','$'
MSG_REV:DB	'   Rev: ','$'
MSG_ID:	DB	'  Type: ','$'
MSG_ATA:DB	'ATA, ','$'
MSG_API:DB	'ATAPI, ','$'
MSG_FIX:DB	'Fixed','$'
MSG_REM:DB	'Removable','$'
MSG_CHS:DB	'   CHS: ','$'
MSG_MLBA:
	DB	'MaxLBA: ','$'
MSG_LBS:DB	'   LBA: ','$'
MSG_YES:DB	'yes','$'
MSG_NO:	DB	'no','$'
MSG_STA:DB	'Status: ','$'
MSG_SPC:DB	', ','$'
MSG_CYH:DB	'Enter LBA in hex (nnnn): ','$'
MSG_HCYH:
	DB	'Enter LBA/H in hex (nn): ','$'
MSG_LBA:DB	'LBA=','$'
MSG_000:DB	'     000102030405060708090A0B0C0D0E0F101112131415161718191A1B1C1D
MSG_012:DB	'     0123456789ABCDEF0123456789ABCDEF',CR,LF,LF,'$'
MSG_PMT:DB	', (R)ead (W)rite (L)BA +/- Spin(U,O) (H)ex(D)ump (F,V) (Q)uit: ',
MSG_SUR:DB	'This will change data on drive, are you sure (Y/N)? ','$'
MSG_FMT:DB	'This will fill sectors on drive with E5h, are you sure (Y/N)? ','
MSG_CHK:DB	'This will read data from drive, are you sure (Y/N)? ','$'
MSG_RD:	DB	'Sector read OK',CR,LF,'$'
MSG_WR:	DB	'Sector write OK',CR,LF,'$'
MSG_FT:	DB	'Drive sector format OK',CR,LF,'$'
MSG_CT:	DB	'Drive sector read test OK',CR,LF,'$'
MSG_ERR:DB	'Error, code = ','$'
MSG_BRK:DB	'<Aborted>',CR,LF,'$'
MSG_IOA:DB	'I/O-Adr: ','$'
MSG_BUF:DB	', Buffer: ','$'
NOMSG:	DB	BELL,'Drive not found!',CR,LF,'$'

;
; Buffer
;
LBA:	DB	0		; sector
	DB	0		; cyl lsb	
	DB	0		; cyl msb
	DB	IDE_DRV		; head 0-15

MAXSEC:	DS	2,0
MAXCYL:	DS	2,0
MAXHDS:	DS	2,0

;
;buffer:	defs	512,0
;
	ENDE
;
	END START

;
;
;
;
; Line numbers containing untranslated opcodes:
;
; 00284 00285 00290 00368 00375 00665 00717 00779 00787 00789
; 00803 00805 00815 01035 01063
;
